package
{
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{
		[Embed(source = "data/map.png")] public static var ImgMap:Class;
		[Embed(source = "data/car1.png")] public static var ImgCar1:Class;
		[Embed(source = "data/car2.png")] public static var ImgCar2:Class;
		[Embed(source = "data/car3.png")] public static var ImgCar3:Class;
		[Embed(source = "data/backdrop.png")] public static var ImgBG:Class;
		[Embed(source = "data/animation.png")] public static var ImgAnim:Class;

		[Embed(source = "data/level1.txt", mimeType="application/octet-stream")] public static var Level1:Class;
//		[Embed(source = "data/bg.png")] private var BgImg:Class;
//		[Embed(source = "data/woman.png")] private var ImgWoman:Class;
		[Embed(source = "data/reve.mp3")] public static var SndMusic:Class;
		[Embed(source = "data/crash.mp3")] public static var SndCrash:Class;
//		[Embed(source = "data/sound.mp3")] public static var SndSound:Class;
//		[Embed(source = "data/gameover.mp3")] public static var SndGameover:Class;

		public var player:Player;
		public var flowers:FlxGroup;
		public var endDoor:EndDoor;
		public var openflowers:FlxGroup;
		public var others:FlxGroup;
		public var collisionGroup:FlxGroup;
		public var spikes:FlxGroup;
		
		public var cars:FlxGroup;
		
		override public function create():void
		{		
			this._time=0;
			bgColor = 0xFF000000;

			spikes = new FlxGroup();
			collisionGroup = new FlxGroup();
			
			
			var a:FlxSprite = new FlxSprite;
			a.loadGraphic(ImgBG,false,false);
			this.add(a);
			
			var anim: FlxSprite = new FlxSprite(92,5);
			anim.loadGraphic(ImgAnim,true,false,31,26);
			anim.addAnimation("loop",[0,1,2,3,4,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,5,6,7,8,9,10,3,2,1],2,true);
			anim.play("loop");
			this.add(anim);
			cars = new FlxGroup();
			this.add(cars);
			for (var i:int = 0;i<12;i++)
			{
				var x:FlxSprite = new FlxSprite(FlxG.width%10,FlxG.height);
				x.y=51+30*(i/2)-15;
				switch (i)
				{
					case 0:
					case 1:
						break;
					case 2:
					case 3:
						break;
					case 4:
					case 5:
						x.y+=2;
						break;
					case 6:
					case 7:
						x.y+=7;
						break;
					case 8:
					case 9:
						x.y+=6;
						break;
					case 10:
					case 11:
						x.y+=8;
						break;
				}
				x.x=Math.random()*FlxG.width;
				switch (int(Math.random()*3))
				{
					case 0:
						x.loadGraphic(ImgCar1,true,true,26,16);
						break;
					case 1:
						x.loadGraphic(ImgCar2,true,true,26,16);
						break;
					case 2:
						x.loadGraphic(ImgCar3,true,true,26,16);
						break;
				}
				
				x.y+=10;
				x.addAnimation("car",[0,1],2,true);
				x.play("car");
				x.scrollFactor.x=0;
				x.scrollFactor.y=0;
				x.velocity.x=20+Math.random()*40;
				
				if (i>=6)
				{
					x.velocity.x*=-1;
					x.facing=FlxSprite.RIGHT;
				}
				else
				{
					x.facing=FlxSprite.LEFT;
				}
				
				cars.add(x);
			}
			
			
			
			

							player = new Player(62,35);
							this.add(player);
							//FlxG.follow(player);
							//FlxG.followBounds(0,0,100000,20*28);
							
		}
		
		public function collectFlower(p:FlxSprite,f:FlxSprite):void
		{
			var _p:Player = p as Player;
			/*if (_p.hasFlower==false)
			{
				_p.hasFlower=true;
				_p.play("idleflower",true);
				f.kill();
			}*/
			
		}
		
		public function overlapOther(p:FlxSprite,o:FlxSprite):void
		{
			var _p:Player = p as Player;
			/*if (_p.hasFlower==true)
			{				
				_p.hasFlower=false;
				_p.play("idle",true);
				o.solid=false;
				o.play("bop",true);
				var openfl:OpenFlower = new OpenFlower(o.x+9,o.y);
				openflowers.add(openfl);
			}*/
			
		}
		
		public var _time:Number;
		
		
		
		override public function update():void
		{
			for (var i:int=0;i<cars.members.length;i++)
			{
				cars.members[i].update();
				if (cars.members[i].velocity.x<0)
				{
					if (cars.members[i].x<-50)
						cars.members[i].x=FlxG.width;
				}
				else
				{
					if (cars.members[i].x>FlxG.width)
						cars.members[i].x=-50;
				}
			}
			
			_time+=FlxG.elapsed;
	
			super.update();
			
			if (player.collide(cars))
			{
				DialogState.Ending=1;
				FlxG.state = new DialogState();
			}			
			else if (player.y>FlxG.height)
			{
				DialogState.Ending=2;
				FlxG.state = new DialogState();
			}
		}
	}
}